<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<?xbl href="bindings.xml"?>
<html><head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title></title>

<link href="xsmiles_style.css" type="text/css" rel="stylesheet">
<style type="text/css">
					td.nav, table.nav, tr.nav,td.contentarea {vertical-align: top; border-width:0px;}
				</style><!--NOTE: THIS FILE IS AUTOMATICALLY GENERATED BY XSL, DO NOT EDIT BY HAND. EDIT FEATURES.XML INSTEAD AND RUN 'build.sh sitedoc--></head><body>
<img alt="X-SMILES.ORG" src="xsmiles.gif"><table class="nav">
<tbody><tr class="nav">
<td class="nav" style="vertical-align: top; width: 100pt;">
     <div id="navbar" class="navbar">
     <div>
     <p id="link-xsmiles" class="link">
      <a class="linkmain" href="index.html">X-Smiles</a>
     </p>
     <p id="link-objectives" class="link">
      <a class="linkmain" href="xsmiles_objectives.html">Objectives</a>
     </p>
     <p id="link-contributors" class="link">
      <a class="linkmain"  href="contributors.html">Contributors</a>
     </p>
     <p id="link-screenshots" class="link">
      <a class="linkmain" href="screenshots.html">Screenshots</a>
     </p>
     <p id="link-downloads" class="link">
      <a class="linkmain" href="download.html">Download</a>
     </p>
     <p id="link-documents" class="link">  
      <a class="linkmain">Documents</a>
      <a class="linksub1" href="xsmiles_features.html">Features</a> 
      <a class="linksub1" href="xsmiles_installation.html">Installation</a>
      <a class="linksub1" href="platforms.html">Platforms</a>
      <a class="linksub1" href="xsmiles_faq.html">FAQ</a>
      <a class="linksub1" href="xsmiles_test.html">Testimonials</a>
     </p>
     <p id="link-developers" class="link">
      <a class="linkmain">Developer Area</a>
      <a class="linksub1" href="participate.html">Participating</a>
      <a class="linksub1" href="techspec.html">Technical Spec</a>
      <a class="linksub1" href="xsmiles_compiling.html">How to compile</a>
      <a class="linksub1" href="xsmiles_future.html">Projects</a>
      <a class="linksub1" href="http://www.xsmiles.org/javadoc/index.html">Javadoc</a>
      <a class="linksub1" href="cvs.html">CVS access</a>
      <a class="linksub1" href="xsmiles_smil.html">SMIL package</a>
      <a class="linksub1" href="http://www.xsmiles.org/demo/demos.xhtml">Demos</a>
     </p>
     <p id="link-reading" class="link">
      <a class="linkmain">Reading</a>
      <a class="linksub1" href="presentations.html">Presentations</a>
      <a class="linksub1" href="publications.html">Publications</a>
     </p>
     <p id="link-feedback" class="link">
      <a class="linkmain">Feedback</a>
      <a class="linksub1" href="http://sourceforge.net/bugs/?group_id=18700"> Bugs</a>
      <a class="linksub1" href="xsmiles_lists.html">Mailing lists</a>
     </p>
    </div>
    </div>
</td><td class="contentarea">
<div class="contentarea">
<h1>X-Smiles FAQ&nbsp;</h1>
<a href="#running">Running X-Smiles</a> 
<br>
<a href="#compiling">Compiling X-Smiles</a> 
<br>
<a href="#contentType">Content-type and Rendering issues</a> 
<br>
<a href="#security">Security issues</a> 
<br>
<br>
<hr style="width: 100%; height: 2px;">
<br>
<h2 id="running">Running X-Smiles</h2>
<h4>R1. Images in the toolbar, below the menus, are not visible</h4>
<p>This is probable due running X-Smiles from somewhere else than where
it was installed. The images used in the toolbar are found in the '<code>img</code>' directory under the installation dir.&nbsp;<br>(Windows) Check <code>xsmiles.bat</code>, it should contain the following lines:</p>
<div class="code">
<code>cd c:\xsmiles<br>c:</code>
</div>
<p>Change them to suit your installation directory.</p>
<hr>
<h4>R2. Starting X-Smiles produced the following error:&nbsp;<br>ERROR: java.lang.IllegalArgumentException: No attributes are implemented&nbsp;</h4>
<p>
<b>JDK 1.2-1.3:</b> This is a classpath problem regarding xerces.jar.
Usually this happens when you have a different parser in the classpath
before xerces.jar, or you have an older version of xerces.jar in the
classpath.&nbsp;</p>
<p>-&gt; remove jaxp.jar ja older xerces.jar from your classpath and
try again. You may also have these jars in the java installation
directory, and you should remove them.&nbsp;</p>
<p>
<b>JDK 1.4:</b> This version ships with
org.apache.crimson.jaxp.DocumentBuilderFactoryImpl, but X-Smiles needs
org.apache.xerces.jaxp.DocumentBuilderFactoryImpl, so the easiest thing
to do is to run X-Smiles with the following command line (this should
be fixed in a future version of X-Smiles):</p> 
<div class="code">
<code>java<br>-Djavax.xml.parsers.DocumentBuilderFactory=org.apache.xerces.jaxp.DocumentBuilderFactoryImpl -jar xsmiles.jar"</code> 
<p>FULL ERROR MESSAGE:</p>
<p>ERROR: java.lang.IllegalArgumentException: No attributes are implemented<br>java.lang.IllegalArgumentException: No attributes are implemented<br>at org.apache.crimson.jaxp.DocumentBuilderFactoryImpl.setAttribute(DocumentBuilderFactoryImpl.java:93)<br>at fi.hut.tml.xsmiles.xml.JaxpXMLParser.openDocument(JaxpXMLParser.java: 114)<br>at fi.hut.tml.xsmiles.xml.JaxpXMLParser.openDocument(JaxpXMLParser.java: 79)<br>at fi.hut.tml.xsmiles.XMLConfigurer.readConfig(XMLConfigurer.java:222)<br>at fi.hut.tml.xsmiles.XMLConfigurer.&lt;init&gt;(XMLConfigurer.java:142)<br>at fi.hut.tml.xsmiles.Browser.&lt;init&gt;(Browser.java:156)<br>at fi.hut.tml.xsmiles.Xsmiles.main(Xsmiles.java:115)</p>
</div>
<hr>
<h4>R4. Running XML Signature produces the following error:</h4>
<div class="code">
<code>[Debug] c:\source\xsmiles\bin\cfg\defaultkey.jks<br>java.lang.VerifyError:
(class: org/bouncycastle/jce/provider/JDKDSASigner, method: derDecode
signature: ([B)[Ljava/math/BigInteger;) Incompatible object argument
for function call<br>&nbsp;&nbsp;&nbsp; at java.lang.Class.getDeclaredConstructors0(Native Method)<br>
</code>
</div>
<br>This is because some overlapping classes in jxtamlfc and
signaturemlfc. Current workaround: remove jxtamlfc.jar from
bin/extensions when using signature.jar. (MH 18-Nov-02).<br>
<hr>
<h4>R4. Starting X-Smiles 0.5 or earlier first under JDK1.4 messes up
the configuration file, after which, X-Smiles cannot be run, even on
JDK 1.3. Bug is fixed since 0.6.</h4>
<p>From a mail from Jukka Santala:</p>
<p>On Thu, 21 Feb 2002 thomas.nagel@materna.de wrote:<br>&gt; i'm trying to use xsmiles 0.5 with the new JDK 1.4.0 Release Candidate 1,<br>&gt; but it throws Null Pointers.&nbsp;<br>&gt; I already used the Switch from the FAQ&nbsp;<br>&gt; "-Djavax.xml.parsers.DocumentBuilderFactory=org.apache.xerces.jaxp.DocumentB<br>&gt; uilderFactoryImpl"<br>&gt; but it does not help.&nbsp;<br>
<br>If you start Xsmiles without the -D flag under JDK 1.4.0, it appears to<br>garble the cfg/config.xml file, which in turn leads to Xsmiles failing to<br>locate many important resources.<br>
<br>The solution is to re-extract config.xml from the original package, and<br>always run Xsmiles with the -D switch under JDK1.4.<br>
<br>Besides of that, Xsmiles 0.5 is not really supported under JDK1.4; there<br>are incompatibilities with some API that prevents use of CSS and SVG.<br>These have been fixed in the CVS version, so you either have to build and<br>run that, or wait for next release if you want to use those features under<br>JDK1.4.<br>
<br>Also, I think final release of JDK 1.4.0 is now out for all platforms, and<br>the pre-release versions have been giving some trouble with Xsmiles, so I<br>would recommend using the newest available version if you want to go 1.4.<br>
<br>Ps. Building Xsmiles should work fine if you have JMF in your CLASSPATH as<br>recommended for JMF install, set JAVA_HOME to the base path of your JDK<br>install (The path element with the JDK version) and use the src/build.sh<br>or src/build.bat scripts depending on architecture to launch the<br>build-tool.<br>
<br>-Jukka Santala</p>
<div class="code">
<code>FULL ERROR MESSAGE</code> 
<p>-*-=XSmiles ver 0.5 starting=-*-<br>Java version: 1.3.1<br>Current dir: E:\xsmiles\bin<br>[Debug] Browser Initializing...<br>...<br>[Debug] XSMilesUI.documentRequired<br>[Debug] XACombo.setText() : <a href="http://www.xsmiles.org/demo/demos.xml">http://www.xsmiles.org/demo/demos.xml</a>
<br>[Debug] Adding <a href="http://www.xsmiles.org/demo/demos.xml">http://www.xsmiles.org/demo/demos.xml</a>
<br>java.lang.NullPointerException<br>java.lang.NullPointerException<br>&nbsp;at fi.hut.tml.xsmiles.Xsmiles.setMLFCMappings(Xsmiles.java:152)<br>&nbsp;at fi.hut.tml.xsmiles.Browser.&lt;init&gt;(Browser.java:179)<br>&nbsp;at fi.hut.tml.xsmiles.Xsmiles.main(Xsmiles.java:126)<br>[Debug] *** New thread started, and retrieving a new document</p>
</div>
<hr>
<div class="code">
<code>-*-=XSmiles ver 0.5 starting=-*-<br>Java version: 1.4.0<br>Current dir: E:\xsmiles\bin<br>[Debug] Browser Initializing...<br>[Debug] *** PARSER: 'null'<br>ERROR: java.lang.IllegalArgumentException: No attributes are implemented<br>java.lang.IllegalArgumentException: No attributes are implemented<br>&nbsp;at org.apache.crimson.jaxp.DocumentBuilderFactoryImpl.setAttribute(DocumentBuilderFactoryImpl.java:93)<br>&nbsp;at fi.hut.tml.xsmiles.xml.JaxpXMLParser.openDocument(JaxpXMLParser.java:129)<br>&nbsp;at fi.hut.tml.xsmiles.xml.JaxpXMLParser.openDocument(JaxpXMLParser.java:78)<br>&nbsp;at fi.hut.tml.xsmiles.XMLConfigurer.readConfig(XMLConfigurer.java:215)<br>&nbsp;at fi.hut.tml.xsmiles.XMLConfigurer.&lt;init&gt;(XMLConfigurer.java:78)<br>&nbsp;at fi.hut.tml.xsmiles.Browser.&lt;init&gt;(Browser.java:148)<br>&nbsp;at fi.hut.tml.xsmiles.Xsmiles.main(Xsmiles.java:126)<br>ERROR: java.lang.IllegalArgumentException: No attributes are implemented<br>...</code>
</div>
<hr style="width: 100%; height: 2px;">
<h4>
<br>
</h4>
<h2 id="compiling">Compiling X-Smiles</h2>
<h3>How do I compile, debug and modify X-Smiles using Eclipse.org<br>
</h3>
<p>
<b>Cause:</b>
<br>You want to modify X-Smiles to your purposes.<br>
<br>
<b>Solution:<br>
</b>
</p>
<ol>
<li>Download and install JDK 5.0 from <a href="http://java.sun.com/">http://java.sun.com/</a>
</li>
<li>Download and install JMF from <a href="http://java.sun.com/products/java-media/jmf/">http://java.sun.com/products/java-media/jmf/</a>
<br>
</li>
<li>Download latest Eclipse milestone (e.g. 3.1M4) from <a href="http://www.eclipse.org/">http://www.eclipse.org</a>.</li>
<li>Install Eclipse.<br>
</li>
<li>Start Eclipse. Create the Workspace directory to your home dir and not to eclipse installation dir. Go to workbench.<br>
</li>
<li>Set up cvs.tml.hut.fi <a href="http://www.xsmiles.org/cvs.html">CVS</a> .</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Window -&gt; Perspective -&gt; CVS repository</li>
<li>Add CVS repository</li>
<li>Host: cvs.tml.hut.fi</li>
<li>Repository path: /cvs</li>
<li>User: anonymous or your CVS user</li>
<li>Passwd: anonymous or your CVS passwd<br>
</li>
<li>Connection type: ext or extssh</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>The "ext" connection method can be configured on the Team/CVS/EXT Connection Method preference page&lt;&gt;&nbsp;&nbsp;&nbsp;<br>
</li>
</ul>
</li>
</ul>
</li>
<li>Pull X-Smiles project from CVS:</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Open HEAD, go to "xsmiles"</li>
<li>Right-click and select: Check out as...</li>
<li>select "Check out as a new project configured using the new project wizard"</li>
<li>select "HEAD"</li>
<li>select "JAva project"</li>
<li>Project name: xsmiles</li>
<li>select "Create separate source and output folders"</li>
<li>Click "Finish", the project will be pulled from the CVS</li>
</ul>
</li>
<li>Configure/compile project</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>After x-smiles has been downloaded from the CVS, open the java perspective</li>
<li>right click xsmiles, and select "Properties"</li>
<li>Source tab - add the xsmiles/src/xsmiles dir as a source dir</li>
<li>Source tab - select output folder to be xsmiles/build</li>
<li>Libraries - add all jar's from xsmiles/bin/lib and xsmiles/bin/lib/endorsed</li>
<li>Order tab: set xerces.jar, xml-apis.jar and xalan.jar on top, before the JDK classes<br>
</li>
<li>Click "ok" and eclipse will start building x-smiles</li>
<li>If you get errors about javax.media., open Properties again and add jmf.jar from your jmf installation to "Libraries" tab</li>
</ul>
</li>
<li>Run X-Smiles</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Create a new run profile</li>
<li>Select fi.hut.tml.xsmiles.gui.gui2.swing.KickStartSwing as the main class</li>
<li>select xsmiles/bin as the working directory</li>
<li>set VM option: "-Djava.endorsed.dirs=lib/endorsed "<br>
</li>
<li>Run X-SMiles</li>
</ul>
</li>
</ol>(Eclipse Instructions written by Mikko Honkala)<br>
<h3>How do I compile and run the J2ME Personal Profile version of X-Smiles?&nbsp;</h3>
<p>
<b>Cause:</b>
<br>X-Smiles needs to be compiled with a different build target using the build script for J2ME Personal Profile.<br>
<br>
<b>Solution:</b>
</p>
<ol>
<li>First, you need to download and unpack or install the <a href="http://java.sun.com/products/personalprofile/download.html">SUN Personal Profile Reference implementation</a>.</li>
<li>Ackquire the X-Smiles CVS version using the instructions in the CVS
access page. Also downloading both the binary and source distibutions
and unpacking them to the same dir should suffice.</li>
<li>Try to comple X-Smiles using the instructions in the compiling page. (Basically <span style="font-weight: bold;">"cd {xsmiles}/src ; sh build.sh clean compile-debug"</span> )</li>
<li>If the previous step worked, try to compile the personal profile version by:<br>&nbsp;<span style="font-weight: bold;">"cd {xsmiles}src; sh build.sh clean jar-personaljava"</span>
</li>
<li>in {xsmiles}/dist/bin there should now be a directory called
personaljava. Change to that dir. There is all the jars needed to run
the personal java version.</li>
<li>Change the path to the J2ME virtual machine (cvm) in runxsmiles shell script<br>or type "<span style="font-weight: bold;">export PATH=$PATH:/PATH_TO_MY_INSTALLATION/j2me-pp1.0/bin/</span>"<br>
</li>
<li>type "<span style="font-weight: bold;">sh runxsmiles</span>"</li>
</ol>
<br>
<h3 id="xine">How do I compile and run the XINE players version of X-Smiles?&nbsp;</h3>Checkout
the xsmiles-jmfxine module from CVS and follow the instructions in
README. Remember to add the created java classes to the CLASSPATH
before running X-Smiles. <hr>
<h3>Compiling/Running gives errors on SVG DOM classes&nbsp;</h3>
<p>
<b>Cause:</b>
<br>XSLFO uses different version of SVG DOM classes than org.csiro packages.<br>
<br>
<b>Solution:</b>
</p>
<p>
<b>This is solved with the following classpath order: xerces.jar;svg.jar;w3c.jar;xalan.jar;...</b>
</p>
<p>Old: Compile the XSLFOMLFC using classpath without the svg.jar and
org.csiro.* classes using classpath with the svg.jar.&nbsp;&nbsp;</p>
<p>Other option is to compile X-Smiles using JDK 1.3 or Jikes.</p>
<hr>
<h3>Compiling X-Smiles from scratch with the Jikes 1.2</h3>
<b>Cause:</b>
<br>Jikes fails on '<b>import xxx.*</b>' when it has not compiled a class in 'xxx' and it is referred to in another .java file.<br>
<br>
<b>Solution:</b>
<br>The work has started to reduce import xxx.* from the classes.<br>The workaround now (with the latest CVS version) is to compile everything 3 times with jikes. <hr>
<h3>Compiling X-Smiles with JDK 1.3 does not produce any class files</h3>
<p>
<b>Cause:</b>
<br>JDK 1.3 does not produce any class files if it encounters an error in any of the java files.<br>
<br>
<b>Solution:</b>
<br>Remove java files that are producing errors from the build</p>
<hr>
<h3>Compiling produces the following error (or similar) :&nbsp;</h3>
<p>DocuverseXMLParser.java:112<br>: class com.docuverse.dom.DOM is an abstract class. It can't be instantiated.<br>dom = new com.docuverse.dom.DOM();</p>
<p>
<b>Cause:</b>
<br>This is a classpath ordering error.<br>
<br>
<b>Solution:</b>
<br>TBD.<br>
</p>
<hr style="width: 100%; height: 2px;">
<h3>Can I use the latest version of Xalan and Xerces? :&nbsp;</h3>No
you cannot. You should use the versions that we distribute. Note that
xalan.jar and xml-apis.jar have to be in the endorsed directory. (See <a href="http://java.sun.com/j2se/1.4.2/docs/guide/standards/">this link</a> for more information).<br>
<br>&lt;&gt;<b>Cause:</b>
<br>We are using special DOM Level 3 functionality (PSVI in XForms,
DOMWriters), which needs a specially build xerces. Additionally, we
need to be jdk 1.1. compliant and Xerces 2.6.0 needs jdk&gt;=1.2. Also,
in XForms we are using special XPath functionality, which is dependent
of the version of Xalan.<br>
<br>
<br>
<b>Solution:</b>
<br>Use the versions that we provide.<br>
<hr style="width: 100%; height: 2px;">
<h2 id="contentType">Embedding X-Smiles<br>
</h2>
<span style="font-weight: bold;">Using X-Smiles in a Java project inside a Container.<br>
</span> 
<p>
<b>Cause:</b>
<br>
</p>Often, it would be nice to use X-Smiles inside your project GUI.<br>
<br>
<b>Solution:<br>
</b>
<br>Check out fi.hut.tml.xsmiles.gui.gui2.KickStart class. It shows a
simple way to instantiate the browser. It uses either the simple AWT
GUI or the Swing GUI that is extended from the AWT GUI. You can also
extend the AWT GUI or create one from scratch.<br>
<br>Remember that you probably need the files in bin/lib and bin/cfg to
run the browser properly. They should be in the working directory.<br>
<hr style="width: 100%; height: 2px;">
<br>
<h2 id="contentType">Content-type issues</h2>
<h3>X-Smiles does not render content, only displays the file in text</h3>
<p>
<b>Cause:</b>
<br>X-Smiles uses the content-type received from the web server to identify content. Many web servers, including apache give</p>
<pre class="code">Content-type: text/plain</pre>for all unidentified
files. Files loaded from the hard disk are identified based on the end
of the filename, they are not effected<br>
<br>
<b>Solution:</b> 
<p>Configure your web server to send correct Content-types. E.g., in apache this is fixed by adding a</p>
<pre class="code">.htaccess</pre>file to your directory. The content-type definitions affect the subdirectories recursively. X-Smiles recognizes <pre class="code">application/xml</pre>types of files. <pre class="code"><br>An example of the .htaccess file:<br>         
<br>AddType application/xml .fo<br>AddType application/smil .smil<br>AddType application/xml .svg<br>AddType application/xml .xfm<br>AddType application/xml .jax<br>AddType application/xml .x3d<br>AddType application/xml .xhtml<br>
<br>
</pre>
<p>Check out fi.hut.tml.xsmiles.gui.gui2.KickStart class. It shows a
simple way to instantiate the browser. It uses either the simple AWT
GUI or the Swing GUI that is extended from the AWT GUI. You can also
extend the AWT GUI or create one from scratch.<br>
<br>Remember that you probably need the files in bin/lib and bin/cfg to
run the browser properly. They should be in the working directory.<br>
</p>
<hr style="width: 100%; height: 2px;">
<br>
<h2 id="security">Security in X-Smiles<br>
</h2>
<p>
<b>Question:</b>
<br>What kind of security features X-Smiles has?<br>
</p>
<b>Answer:</b>
<br>
<p>The security features in X-Smiles are currently not perfect, but
some work on that area has been done after 0.91 release. JavaScript can
access the extended DOM, which may be exploited by a malicious script.</p>
<p>Here's a short list of what's working and what is not:<br>
</p>
<ul>
<li>General Security Policy</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>There is a xsmiles.policy file, which sets different security
policies to different jars in the project, for instance, it does not
allow js.jar to write to disk.<br>
</li>
</ul>
</li>
<li>Scripts</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Scripts are run in a separate security sandbox defined in: ScriptSecurityZone, RhinoScripter, and XSmilesWrapFactory<br>
</li>
</ul>
<ul>
<li>Scripts are not allowed to create any java classes directly. This
is imposed by the class fi.hut.tml.xsmiles.ecma.rhino.RhinoScripter,
which implements ClassShutter and blocks creation of any Java class</li>
<li>Scripts can traverse the DOM tree and access few objects, such as
window and document. The class XSmilesWrapFactory takes care of not
giving access to other classes. If you need your class to be accessible
you need to implement the AccessibleToScripts interface. Make sure that
there are no dangerous methods in your DOM classes.<br>
</li>
</ul>
<ul>
<li>TODO: Scripts should only be able to access certain methods in the objects that are exposed (e.g. the DOM tree in document)<br>
</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>This is not so dangerous anymore, because of the two previous security fixes.</li>
</ul>
</li>
</ul>
</li>
<li>Applets</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Applets are run in a separate security sandbox defined in: AppletClassLoader</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Applets from file: can access files under the same dir</li>
<li>Applets from http: can resolve and connect to the same host</li>
<li>Properties listed in : <a href="http://java.sun.com/docs/books/tutorial/applet/practical/properties.html">http://java.sun.com/docs/books/tutorial/applet/practical/properties.html</a>
<br>
</li>
<li>No other permissions are given<br>
</li>
</ul>
</li>
</ul>
</li>
<li>XForms</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>If the form tries to save to local disk, the user has to authorize the request</li>
<li>TODO: do not allow to read from different scheme (especially file:) when http: is used</li>
<li style="list-style-type: none; list-style-image: none; list-style-position: outside;">
<ul>
<li>Currently it is possible to read an xml file from the users local drive as an instance and submit it to the server</li>
</ul>
</li>
</ul>
</li>
</ul>
<br>
<hr style="width: 100%; height: 2px;">
<br>
<p>
<b>Question:</b>
<br>I get an security exception when trying to run x-smiles in a development environment?<br>
</p>
<b>Answer:</b>
<br>You should be running your classfiles from "build/". If you compile
them to a different directory, you must set a system property
"app.dev.base" to e.g. "classes/". This is because the policy file sets
properties based on the directory.<br>
<br>
<hr>
		  Copyright (c) 2000-2007 X-Smiles.org et.al.
	</div>
</td>
</tr>
</tbody></table>

</body></html>